'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactUikitBase = require('react-uikit-base');

var _reactUikitBase2 = _interopRequireDefault(_reactUikitBase);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Button = function Button(props) {
  // CSS classes
  var context = {
    primary: ' uk-button-primary',
    success: ' uk-button-success',
    danger: ' uk-button-danger',
    link: ' uk-button-link'
  };

  var size = {
    mini: ' uk-button-mini',
    small: ' uk-button-small',
    large: ' uk-button-large'
  };

  var cssClassNames = _reactUikitBase2.default.helpers.cleanClasses(['uk-button', props.classes, props.block ? 'uk-width-1-1' : null, props.context ? context[props.context] : null, props.size ? size[props.size] : null, props.className]);

  // Elements
  var ignoreProps = ['type'];
  var cleanProps = _reactUikitBase2.default.helpers.cleanProps(ignoreProps)(props);

  var attr = _extends({}, _reactUikitBase2.default.events(props), {
    'data-kitid': props.kitid
  });

  var type = {
    button: _react2.default.createElement(
      'button',
      _extends({}, cleanProps, attr, {
        className: cssClassNames,
        type: 'button',
        disabled: props.disabled
      }),
      props.body,
      props.children
    ),

    close: _react2.default.createElement('a', _extends({}, cleanProps, attr, {
      className: 'uk-close ' + cssClassNames,
      href: '#'
    })),

    link: _react2.default.createElement(
      'a',
      _extends({}, cleanProps, attr, {
        className: cssClassNames,
        href: '#',
        role: 'button'
      }),
      props.body,
      props.children
    )
  };

  // Return Component
  return type[props.type] || type['button'];
};

Button.propTypes = {
  body: _react2.default.PropTypes.string,
  block: _react2.default.PropTypes.bool,
  context: _react2.default.PropTypes.oneOf(['primary', 'success', 'danger', 'link']),
  disabled: _react2.default.PropTypes.bool,
  size: _react2.default.PropTypes.oneOf(['mini', 'small', 'large']),
  type: _react2.default.PropTypes.oneOf(['button', 'close', 'link'])
};

exports.default = _reactUikitBase2.default.base(Button);